#
#       TRISPEC REDUCTION SUB ROUTINE
#
#       trimjdave.cl: Calculate mean time
#
#
#
procedure trimjdave( inlist )

file inlist  { prompt = "Input image list" }

begin

  file infn
  file logfn = "TRI.ave.log"
  string fn[300]
  int n_list
  file fn1
  string timestr
  int hr, min, sec
  real timesum, time1
  real fzsum
  real fz1, fz2, fz
  string buf

  infn = inlist

### read list file ###

  if( access( infn ) )
  {
    printf( "INLIST '%s' found. ", infn )
  }
  else
  {
    while( access( infn ) == 0 )
    {
      printf( "INLIST '%s' not found. Enter file name >> ", infn )
      c = scan( infn )
    }
    printf( "INLIST '%s' found. ", infn )
  }

  n_list = 0
  list = infn
  while( fscan( list, buf ) != EOF )
  {
    n_list += 1
    fn[n_list] = buf
  }
  printf( "%d files registed.\n", n_list )


### main routine ###

  timesum = 0.0  
  fzsum = 0.0
  inrsum = 0.0

  for( i=1; i<=n_list; i+=1 )
  {
    fn1 = fn[i]

    imgets( fn1, 'HST' )
    timestr = substr( imgets.value, 23, 30 )
    hr = int( substr( timestr, 1, 2 ) )
    min = int( substr( timestr, 4, 5 ) )
    sec = int( substr( timestr, 7, 8 ) )
    time1 = hr + min / 60.0 + sec / 3600.0
    timesum += time1

    imgets( fn1, 'AIRMASS' )
    fz1 = real( imgets.value )
    imgets( fn1, 'AIRMASS' )
    fz2 = real( imgets.value )
    fz = ( fz1 + fz2 ) / 2.0
    fzsum += fz

  }

  printf( "Average TIME = %7.5f\n", ( timesum / n_list ) )
  printf( "Average F(z) = %7.4f\n", ( fzsum / n_list ) )

  printf( "focmjdave %s \n", infn, >> logfn )
  type( infn, >> logfn )
  printf( "Average TIME = %7.5f\n", ( timesum / n_list ), >> logfn )
  printf( "Average F(z) = %7.4f\n", ( fzsum / n_list ), >> logfn )
  printf( "\n", >> logfn )


  printf( "Log appended '%s'.\n", logfn )

end
