#
#       TRI REDUCTION SUB ROUTINE
#
#       extract 4 two-dimensional spectra reffering an image
#                                               : triapext.cl
#
#       1997/07/15      K.Kawabata  Ver. 1.00
#       1998/02/06      K.Kawabata  ver. 2.00
#
#
#    !!! WARNING: File name must not be included '.imh' !!!
#

procedure triapext( infile, refdir, outfile1, outfile2, outfile3, outfile4, yp1, yp2, yp3, yp4 )

string infile { prompt = "Input image" }
string refdir { prompt = "Directroy of 1to1-FIT data" }
string outfile1 { prompt = "Output image Sp1" }
string outfile2 { prompt = "Output image Sp2" }
string outfile3 { prompt = "Output image Sp3" }
string outfile4 { prompt = "Output image Sp4" }
int    yp1 { prompt = "Extraction start point of SP1" }
int    yp2 { prompt = "Extraction end point of SP1" }
int    yp3 { prompt = "Extraction start point of SP2" }
int    yp4 { prompt = "Extraction end point of SP2" }

begin

  file fn
  file fn1, fn2, fn3, fn4
  string tmp1, tmp2, tmp3, tmp4
  string rdir
  int y1, y2, y3, y4

  rdir = refdir
  fn = infile
  fn1 = outfile1
  fn2 = outfile2
  fn3 = outfile3
  fn4 = outfile4
  y1 = yp1
  y2 = yp2
  y3 = yp3
  y4 = yp4

  tmp1 = mktemp( "tri.tmp.image." )
  tmp2 = mktemp( "tri.tmp.image." )
  tmp3 = mktemp( "tri.tmp.image." )
  tmp4 = mktemp( "tri.tmp.image." )

  printf( "Transforming Y.." )
  triscy( fn, rdir, tmp1//".fits", tmp2//".fits" )
  printf( " X.." )
  triscx( tmp1//".fits", tmp2//".fits", rdir, tmp3//".fits", tmp4//".fits" )

  printf( "  extracting..." )
  imcopy( tmp3//"[*,"//y1//":"//y2//"]", fn1, ver- )
  imcopy( tmp4//"[*,"//y1//":"//y2//"]", fn2, ver- )
  imcopy( tmp3//"[*,"//y3//":"//y4//"]", fn3, ver- )
  imcopy( tmp4//"[*,"//y3//":"//y4//"]", fn4, ver- )

  imdelete( tmp1//".fits", ver- )
  imdelete( tmp2//".fits", ver- )
  imdelete( tmp3//".fits", ver- )
  imdelete( tmp4//".fits", ver- )

  tricoord( fn1 )
  tricoord( fn2 )
  tricoord( fn3 )
  tricoord( fn4 )
  printf( "  Done.\n"  )

end
