#
#	TRISPEC REDUCTION SUB ROUTINE
#
#	Adding useful header : trifconv.cl
#
#       2006/11/27      K.Kawabata    Ver.0.50
#

procedure trifconv

begin
  
  int c = 0
  file list_fn
  string fn_head
  file fn
  string fn_last3
  int n_image
  string buf, buf1, buf2, buf3, buf4, buf5
  string datatyp, filter
  real a
  file logfn

#--- initial settings

  logfn = envget( "_logfile" )

#----- read difinition file
  buf1 = ""
  buf2 = ""
  buf3 = ""

  if( access( "tri.tmp.time" ) == 1 )
    delete( "tri.tmp.time", ver- )
  time >> tri.tmp.time
  list = "tri.tmp.time"
  if( fscan( list, buf, buf1, buf2 ) != 3 )
  {
    printf( "Error: time task -- reading\n" )
    bye
  }
  delete( "tri.tmp.time", ver- )

  printf( "\n" )
  printf( "%s %s\n", buf1, buf2 )
  printf( "-----------------\n" )
  printf( " File Conversion\n" )
  printf( "-----------------\n" )
  printf( "CALDIR=%s\n", envget( "_caldir" ) )
  printf( "\n" )

  printf( "\n", >> logfn )
  printf( "%s %s\n", buf1, buf2, >> logfn )
  printf( "-----------------\n", >> logfn )
  printf( " File Conversion\n", >> logfn )
  printf( "-----------------\n", >> logfn )
  printf( "CALDIR=%s\n", envget( "_caldir" ), >> logfn )
  printf( "\n", >> logfn )

#----- Header addition

  list_fn = envget( "_imagelist" )
#  ext_ir1 = envget( "_IR1ext" )
#  ext_ir2 = envget( "_IR2ext" )
#  ext_opt = envget( "_OPText" )

  list = list_fn
  n_image = 0
  buf5 = ""
  while( fscan( list, buf1, buf2, buf3, buf4, buf5 ) != EOF )
  {
    n_image += 1
    fn_head = buf1
    printf( "%3d %s %s %s %s\n", n_image, buf1, buf2, buf3, buf4 )
    printf( "%3d %s %s %s %s\n", n_image, buf1, buf2, buf3, buf4,\
            >> logfn )

    fn = fn_head
    c = strlen( fn )
    fn_last3 = substr( fn, (c-2), c )

    if( buf3 == "0" )
      next
    if( buf3 == "1" )
      datatyp = "OBJECT"
    if( buf3 == "2" )
      datatyp = "DARK"
    if( buf3 == "3" )
      datatyp = "COMPARISON"
    if( buf3 == "4" )
      datatyp = "BIAS"
    if( buf3 == "5" )
      datatyp = "FLAT"

    if( buf4 == "0" )
    {
      filter = "NO_FILTER"
    }
    else
    {
      if( buf4 == "1" )
      {
        filter = "POL"
      }
      else
      {
        filter = buf4
      }
    }

    if( access( fn//".fits" ) == 1 ){
      hedit( fn, fields="TRITITLE", value=buf2, add+, addonly-,\
             delete-, verify-, show-, update+ )
      hedit( fn, fields="DATA-TYP", value=datatyp, add+, addonly-,\
             delete-, verify-, show-, update+ )
      hedit( fn, fields="COMMFILT", value=filter, add+, addonly-,\
             delete-, verify-, show-, update+ )

      imgets( fn//".fits", 'RET-ANG' )
      a = real( imgets.value )
      hedit( fn, fields="POS-HWP", value=a, add+, addonly-,\
             delete-, verify-, show-, update+ )

      imgets( fn//".fits", 'MJD' )
      if( imgets.value == "---" )
      {
        hedit( fn, fields="MJD", value=-999, add+, addonly-,\
               delete-, verify-, show-, update+ )
      }
      imgets( fn//".fits", 'AIRMASS' )
      if( imgets.value == "---" )
      {
        hedit( fn, fields="AIRMASS", value=-999, add+, addonly-,\
               delete-, verify-, show-, update+ )
      }

      if( buf5 == "phonly" )
      {
        hedit( fn, fields="POS-HWP", value=0.0, add+, addonly-,\
               delete-, verify-, show-, update+ )
      }
      buf5=""


      if( fn_last3 == "OPT" )
      {
        imgets( fn//".fits", 'TEXP_OPT' )
        buf1 = imgets.value
        if( int( buf1 ) == 0 )
        {
          printf( ">> Wrong exposure record in '%s' (%s)\n",\
                  fn, buf1 )
          printf( "   Enter correct exposure time in sec >>> " )
          printf( ">> Wrong exposure record in '%s' (%s)\n",\
                  fn, buf1, >> logfn )
          printf( "   Enter correct exposure time in sec >>> ", >> logfn )
          buf2 = "0"
          c = scan( buf2 )
          while( int( buf2 ) <= 0 )
            c = scan( buf2 )
          buf3 = str( int( buf2 ) * 1000 )
          printf( "%s\n", buf3, >> logfn )
          hedit( fn, fields="TEXP_OPT", value=buf3, add+, addonly-,\
                 delete-, verify-, show-, update+ )
          buf1 = buf3
        }
        buf3 = str( int( buf1 ) / 1000 )
        hedit( fn, fields="EXPTIME", value=buf3, add+, addonly-,\
               delete-, verify-, show-, update+ )
      }
      if( fn_last3 == "IR1" )
      {
        imgets( fn//".fits", 'TEXP_IR1' )
        buf1 = imgets.value
        buf2 = str( int( buf1 ) / 1000 )
        hedit( fn, fields="EXPTIME", value=buf2, add+, addonly-,\
               delete-, verify-, show-, update+ )
      }
      if( fn_last3 == "IR2" )
      {
        imgets( fn//".fits", 'TEXP_IR2' )
        buf1 = imgets.value
        buf2 = str( int( buf1 ) / 1000 )
        hedit( fn, fields="EXPTIME", value=buf2, add+, addonly-,\
               delete-, verify-, show-, update+ )
      }
      
      printf( "     Header updated in %s.\n", fn )
      printf( "     Header updated in %s.\n", fn, >> logfn )
    }
    else
    {
      printf( "Cannot find %s. Skip.\n", fn )
      printf( "Cannot find %s. Skip.\n", fn, >> logfn )
    }

  }

  printf( "%d images are recorded\n", n_image )
  printf( "%d images are recorded\n", n_image, >> logfn )

end
