#
#	HBS REDUCTION SUB ROUTINE
#
#	Grouping images: trigroup.cl
#
#	2005/11/27  Ver 0.5  K.Kawabata
#

procedure trigroup

begin

  string grouplist[500], grouplistsub[500]
  real groupjd[500]
  int ngrlim = 500
  string list_fn
  string listoflist
  string calmode = "" # 1:object, 2:UP,SP,GT
  file fn_record
  file tmp_list
  string outfile, outfilesub
  string datatyp, title, filter
  string shorttyp
  string diaph, slit
  real obsjd
  int flag_obj = 0 # 0:no OBJ group  1: OBJ group exist
  int c
  string buf = ""
  string buf1, buf2
  int n_group, n_tmp, i
  file logfn
  string fn_head
  file fn
  string fn_last3
  string expt

#--- initial settings
  tmp_list = mktemp( "hbs.tmp.fn." )
  listoflist = envget( "_rootlist" )
  logfn = envget( "_logfile" )

  calmode = envget ( "_objcal" )

  if( access( "tri.tmp.time" ) == 1 )
    delete( "tri.tmp.time", ver- )
  time >> tri.tmp.time
  list = "tri.tmp.time"
  if( fscan( list, buf, buf1, buf2 ) != 3 )
  {
    printf( "Error: time task -- reading\n" )
    bye
  }
  delete( "tri.tmp.time", ver- )

  printf( "\n" )
  printf( "%s %s\n", buf1, buf2 )
  printf( "-----------------\n" )
  printf( " Grouping Images\n" )
  printf( "-----------------\n" )
  printf( "\n" )

  printf( "\n", >> logfn )
  printf( "%s %s\n", buf1, buf2, >> logfn )
  printf( "-----------------\n", >> logfn )
  printf( " Grouping Images\n", >> logfn )
  printf( "-----------------\n", >> logfn )
  printf( "\n", >> logfn )

#--- DELETE OLD FILES

  if( access( listoflist ) == 1 )
    delete( listoflist, ver- )

  sections( "TRI.???.*", option="fullname", > tmp_list )

  if( sections.nimages > 0 )
    delete( "@"//tmp_list )

  delete( tmp_list, ver- ) 
 

#--- INITIALIZE VARIABLES

  n_group = 0
  for( i=1; i<=100; i+=1 )
  {
    grouplist[i] = ""
    grouplistsub[i] = ""
    groupjd[i] = 0.0
  }

  diaph = "2S2L"
  slit = "2.00"

#--- GROUPING IMAGES

  list_fn = envget( "_imagelist" )

  list = list_fn

  print( "now grouping images..." )
  while( fscan( list, buf ) != EOF )
  {
    fn_head = buf
    fn = fn_head
    fn_record = buf//".fits"
    c = strlen( fn )
    fn_last3 = substr( fn, (c-2), c )

#    fn_record = buf//"fit.imh"
#    fn = buf//"px.1.imh"

    if( access( fn//".fits" ) == 1 )
    {
      imgets( fn, 'DATA-TYP' )
      datatyp = imgets.value
      shorttyp = substr( datatyp, 1, 3 )
      if( shorttyp == "OBJ" )
        flag_obj = 1

      imgets( fn, 'TRITITLE' )
      title = imgets.value

      imgets( fn, 'EXPTIME' )
      expt = str( int( imgets.value ) )

      imgets( fn, 'COMMFILT' )
      buf = imgets.value
      k = strlen( buf )
      if( k > 5 )
      {
        if( buf == "NO_FILTER" )
          filter = "NO"
        else
          filter = substr( buf, 1, 3 )//substr( buf, (k-1), k )
      }
      else
      {
        filter = buf
      }

      imgets( fn, 'MJD' )
      obsjd = real( imgets.value )

      outfile = "TRI."//shorttyp//"."//title//"."

      outfilesub = "TRI."//shorttyp//"."//title//"."\
                   //expt//"_"//filter


      if( n_group == 0 )
      {
        n_group = 1
        goto p1
      }
      for( i=1; i<=n_group; i+=1 )
      {
        if( calmode == "1" )
        {
          if( outfilesub == grouplistsub[i] )
          {
            outfile = grouplist[i]
            groupjd[i] = obsjd
            goto p2
          }
        }
        else
        {
          if( outfilesub == grouplistsub[i] && abs( obsjd - groupjd[i] ) < 0.4 )
          {
            outfile = grouplist[i]
            groupjd[i] = obsjd
            goto p2
          }
        }
      }
      n_group += 1
      if( n_group > ngrlim )
      {
        print( "Number of searched group exceeds %d", ngrlim )
        print( "!*!*! grouping is finished insted of incompletion !*!*!" )
        print( "Number of searched group exceeds %d", ngrlim, >> logfn )
        print( "!*!*! grouping is finished insted of incompletion !*!*!",\
         >> logfn )
        goto p3
      }

p1 :
      n_tmp = 1
      for( i=1; i<=(n_group-1); i+=1 )
      {
        if( outfile == substr( grouplist[i], 1, strlen( outfile ) ) )
          n_tmp += 1
      }
      grouplistsub[n_group] = outfilesub
      grouplist[n_group] = outfile//n_tmp
      groupjd[n_group] = obsjd
      outfile = grouplist[n_group]

      print( outfile//"   "//shorttyp//" "//title//" "//expt//" "\
             //diaph//" "//filter//" "//slit, >> listoflist )

p2 :

      print( fn_record, >> outfile )

      printf( "%s  %s  %s\n", fn_record, outfilesub, outfile )
      printf( "%s  %s  %s\n", fn_record, outfilesub, outfile, >> logfn )
    }

  }

p3 :

#--- PRINT and CONFIRMATION

#  if( access( inlist ) == 1 )
#    delete( inlist, ver- )

  printf( "\nGrouping results...\n" )
  for( i=1; i<=n_group; i+=1)
  {
    printf( "-- %s  (%s) --\n", grouplist[i], grouplistsub[i] )
    type( grouplist[i] )
    printf( "-- %s  (%s) --\n", grouplist[i], grouplistsub[i], >> logfn )
    type( grouplist[i], >> logfn )
  }

  print("Number of detected group = ", n_group)
  print("Number of detected group = ", n_group, >> logfn)


#--- set parameters

  if( flag_obj == 1 )
    triparam

end
