#
#       TRI REDUCTION SUB ROUTINE
#
#       Trimming : tritrim.cl
#
#
procedure tritrim

begin

  file fn, fn1, fn2, fnnext
  string fn_stack[500]
  int n_image
  file tmp_list
  int i, j, c
  file logfn
  string trilist[500]
  string shorttyp[500], title[500]
  string exptime[500], diaph[500], filter[500]
  string slit[500]
  string listoflist, buf
  string buf1, buf2, buf3, buf4, buf5, buf6, buf7
  int n_list
  file fn_def
  int x1, x2, y1, y2
  int flag_erase # 0:keep old images, 1:erase old images

  int flag_inquiry    # 1: 'flag_overwrite' applys to all image
  int flag_overwrite  # 0:skip 1:overwrite
  int flag_ver  # 0:no display 1:display

#--- initial settings
  logfn = envget( "_logfile" )

  if( access( "tri.tmp.time" ) == 1 )
    delete( "tri.tmp.time", ver- )
  time >> tri.tmp.time
  list = "tri.tmp.time"
  if( fscan( list, buf, buf1, buf2 ) != 3 )
  {
    printf( "Error: time task -- reading\n" )
    bye
  }
  delete( "tri.tmp.time", ver- )

  print( "" )
  printf( "%s %s\n", buf1, buf2 )
  print( "----------" )
  print( " Trimming" )
  print( "----------" )
  print( "" )

  print( "", >> logfn )
  printf( "%s %s\n", buf1, buf2, >> logfn )
  print( "----------", >> logfn )
  print( " Trimming", >> logfn )
  print( "----------", >> logfn )
  print( "", >> logfn )

  fn_def = envget( "_caldir" )//envget( "_defhname" )
  listoflist = envget( "_rootlist" )
  tmp_list = mktemp( "tri.tmp.list." )

  if( access( listoflist ) == 0 )
  {
    print( "Cannot find "//listoflist//"   Please do trigroup" )
    print( "Cannot find "//listoflist//"   Please do trigroup", >> logfn )
    bye
  }


#--- Verbose Mode

  if( envget( "_fg_ver" ) == "1" )
  {
    flag_ver = 1
  }
  else
  {
    if( envget( "_fg_ver" ) == "2" )
    {
      flag_ver = 0
    }
    else
    {
      printf( "'triinit' process is incomplete.(_fg_ver) Retry.\n" )
      printf( "'triinit' process is incomplete.(_fg_ver) Retry.\n", >> logfn )
      bye
    }
  }

#----- Replace Mode

  if( envget( "_fg_mode" ) == "1" )
  {
    flag_inquiry = 1
    flag_overwrite = 1
  }
  else
  {
    if( envget( "_fg_mode" ) == "2" )
    {
      flag_inquiry = 1
      flag_overwrite = 0
    }
    else
    {
      if( envget( "_fg_mode" ) == "3" )
      {
        flag_inquiry = 0
        flag_overwrite = 0
      }
      else
      {
        printf( "'triinit' process is incomplete.(_fg_mode) Retry.\n" )
        printf( "'triinit' process is incomplete.(_fg_mode) Retry.\n",\
                >> logfn )
        bye
      }
    }
  }
    
#----- Erase/Reserve old image

  if( envget( "_fg_del1" ) == "1" )
  {
    flag_erase = 1
  }
  else
  {
    if( envget( "_fg_del1" ) == "2" )
    {
      flag_erase = 0
    }
    else
    {
      printf( "'triinit' process is incomplete.(_fg_del1) Retry.\n" )
      printf( "'triinit' process is incomplete.(_fg_del1) Retry.\n", >> logfn )
      bye
    }
  }

#----- read trim data

  x1 = 0
  x2 = 0
  y1 = 0
  y2 = 0

  if( access( fn_def ) == 0 )
  {
    printf( "Cannot find %s\n", fn_def )
    printf( "Cannot find %s\n", fn_def, >> logfn )
    bye
  }
  list = fn_def
  while( fscan( list, buf1, buf2, buf3 ) != EOF )
  {
    if( buf2 == "X1" )
      x1 = int( buf3 )
    if( buf2 == "X2" )
      x2 = int( buf3 )
    if( buf2 == "Y1" )
      y1 = int( buf3 )
    if( buf2 == "Y2" )
      y2 = int( buf3 )
  }
  if( 1.0 * x1 * x2 * y1 * y2 < 0.00001)
  {
    printf( "read error in %s\n", fn_def )
    printf( "read error in %s\n", fn_def, >> logfn )
    bye
  }
  else
  {
    printf( "x1 = %d  x2 = %d  y1 = %d  y2 = %d\n", x1, x2, y1, y2 )
    printf( "x1 = %d  x2 = %d  y1 = %d  y2 = %d\n", x1, x2, y1, y2, >> logfn )
  }

#----- Scanning the list file

  n_list = 0
  list = listoflist
  while( fscan(list, buf1, buf2, buf3, buf4, buf5, buf6, buf7) != EOF )
  {
    if( substr( buf1, 1, 3 ) != "TRI" )
    {
      print( "The list-file ", listoflist, " is not produced by TRIGROUP.CL" )
      print( "The list-file ", listoflist, " is not produced by TRIGROUP.CL",\
             >> logfn )
      break
    }
    n_list += 1
    trilist[n_list] = buf1
    shorttyp[n_list] = buf2
    title[n_list] = buf3
    exptime[n_list] = buf4
    diaph[n_list] = buf5
    filter[n_list] = buf6
    slit[n_list] = buf7
  }

#----- Main routine

  for( i=1; i<=n_list; i+=1 )
  {
    if( shorttyp[i] != "DAR" && shorttyp[i] != "BIA" &&\
        shorttyp[i] != "NEA" )
    {
      if( flag_ver == 1 )
        printf( "--- OBJECT LIST : %s ---\n", trilist[i] )
      printf( "--- OBJECT LIST : %s ---\n", trilist[i], >> logfn )

      sed( 's/fits//', trilist[i], > tmp_list )

      n_image = 0
      list = tmp_list
      while( fscan( list, buf ) != EOF )
      {
        n_image += 1
	fn_stack[n_image] = buf
      }
      delete( tmp_list, ver- )

      for( j=1; j<=n_image; j+=1 )
      {
        fn = fn_stack[j]

        fn1 = fn//"d"
        fn2 = fn//"tr"

	if( j < n_image )
         fnnext = fn_stack[j+1]//"tr"
	else
         fnnext = "none"

        if( access( fn1//".fits" ) == 0 ){
          if( flag_ver == 1 )
          {
            printf( "%s--(not exist. skip.)  ", fn1 )
            printf( "%s--(not exist. skip.)  ", fn1, >> logfn )
          }
          next
        }

        if( access( fn2//".fits" ) == 1 ){

          if( flag_overwrite == 0 )
          {
            if( fnnext != "none" && access( fnnext//".fits" ) == 0 )
            {
	      printf( "\n%s: Maybe insufficient proccess last time.\n",\
	              fn2 )
	      printf( "\n%s: Maybe insufficient proccess last time.\n",\
	              fn2, >> logfn )
              goto inquiry
            }

            if( flag_inquiry == 1 )
            {
              if( flag_ver == 1 )
                printf( "%s--(already exists. skip.)  ", fn2 )
              printf( "%s--(already exists. skip.)  ", fn2, >> logfn )
              next
            }
            else
	    {
              printf( "\n%s already exist.\n", fn2 )
              printf( "\n%s already exist.\n", fn2, >> logfn )
          inquiry:
              printf( "Overwrite? (apply-this-image-only:[y/n], all:[Y/N]) >> " )
              printf( "Overwrite? (apply-this-image-only:[y/n], all:[Y/N]) >> ", >> logfn )
              c = scan( buf )
              while( buf != "Y" && buf != "y" && buf != "n" && buf != "N" )
                c = scan( buf )
              printf( "%s\n", buf, >> logfn )
              if( buf == "Y" )
              {
                flag_inquiry = 1
                flag_overwrite = 1
              }
              if( buf == "N" )
              {
                flag_inquiry = 1
                flag_overwrite = 0
                if( flag_ver == 1 )
                {
                  printf( "%s--(already exists. skip.)  ", fn2 )
                  printf( "%s--(already exists. skip.)  ", fn2, >> logfn )
                }
                next
              }
              if( buf == "n" )
              {
                if( flag_ver == 1 )
                {
                  printf( "%s--(already exists. skip.)  ", fn2 )
                  printf( "%s--(already exists. skip.)  ", fn2, >> logfn )
                }
                next
              }
            }
          }
          if( flag_ver == 1 )
            printf( "%s(overwrite)  ", fn2 )
          printf( "%s(overwrite)  ", fn2, >> logfn )
          imdelete( fn2, ver- )
        }
        else
        {
          if( flag_ver == 1 )
            printf( "%s  ", fn2 )
          printf( "%s  ", fn2, >> logfn )
        }

#----- Trimming image

        imcopy( fn1//"["//x1//":"//x2//","//y1//":"//y2//"]", fn2, ver- )

	if( access( fn2//".fits" ) == 0 )
	{
	  printf( "Trim Failed. Abnormal end.\n" )
	  printf( "Trim Failed. Abnormal end.\n", >> logfn )
	  bye
	}

	tricoord( fn2 )
        hedit( fn2, 'HISTORY', "trimmed by ["//x1//":"//x2//","\
	       //y1//":"//y2//"]", add+, del-, ver-, show-,\
	       update+, mode=mode )

	if( flag_erase == 1 )
          imdelete( fn1, ver- )
      }

      if( flag_ver == 1 )
        printf( "\n" )
      printf( "\n", >> logfn )
    }
  }

end
